#include <def21369.h>
#include <cdef21369.h>
#include <signal.h>

#define N 10

extern void InitSRU(void);

void UART0_Tx_isr(int dummy);
void UART1_Tx_isr(int dummy);
void UART0_Rx_isr(int dummy);
void UART1_Rx_isr(int dummy);

int tx_data1[N];
int tx_data2[N];

int rx_data1[N];
int rx_data2[N];

int tx_count1 = 0;
int rx_count1 = 0;

int tx_count2 = 0;
int rx_count2 = 0;

int temp;

void main()
{
	int i;
	
    InitSRU();
	
	for( i = 0; i < N; i++ )
	{
	 	tx_data1[i] = i*10;   
	 	tx_data2[i] = i;   
	}
	
	*pPICR0 = 0x9DA95;
	
	interrupt(SIG_P0, UART0_Tx_isr);
	interrupt(SIG_P1, UART1_Rx_isr);
	interrupt(SIG_P2, UART1_Tx_isr);
	interrupt(SIG_P3, UART0_Rx_isr);
	
	*pUART0LCR =  UARTWLS8 | UARTSTB;
	*pUART1LCR =  UARTWLS8 | UARTSTB;
	
	*pUART0LCR |= UARTDLAB;
	
	*pUART0DLL = 10;
	*pUART0DLH = 0;
	
	*pUART0LCR ^= UARTDLAB;
	
	*pUART1LCR |= UARTDLAB;
	
	*pUART1DLL = 10;
	*pUART1DLH = 0;
	
	*pUART1LCR ^= UARTDLAB;
		
	*pUART0IER = 0;
	*pUART0SCR = 0;
	*pUART0MODE = 0;
	
	*pUART1IER = 0;
	*pUART1SCR = 0;
	*pUART1MODE = 0;
	
	*pIIUART0TX = (unsigned int)tx_data1;
	*pIMUART0TX = 1;
	*pCUART0TX = N;
		
	*pIIUART0RX = (unsigned int)rx_data1;
	*pIMUART0RX = 1;
	*pCUART0RX = N;
	
	*pIIUART1TX = (unsigned int)tx_data2;
	*pIMUART1TX = 1;
	*pCUART1TX = N;
		
	*pIIUART1RX = (unsigned int)rx_data2;
	*pIMUART1RX = 1;
	*pCUART1RX = N;
	
	*pUART1RXCTL = UARTEN | UARTDEN;
	*pUART0TXCTL = UARTEN | UARTDEN;
	*pUART0RXCTL = UARTEN | UARTDEN;
	*pUART1TXCTL = UARTEN | UARTDEN;
	
	while(1)
	{
		asm("nop;");	
	}
}

void UART0_Tx_isr(int dummy)
{
	tx_count1++;
}

void UART1_Tx_isr(int dummy)
{
	tx_count2++;
}

void UART0_Rx_isr(int dummy)
{
	rx_count1++;
}

void UART1_Rx_isr(int dummy)
{
	rx_count2++;
}

